LiborForwardModelProcess Class Reference
Stochastic processes

libor-forward-model process More...

`#include <ql/legacy/libormarketmodels/lfmprocess.hpp>`

Inheritance diagram for LiborForwardModelProcess:
[legend]

## Public Member Functions

| LiborForwardModelProcess (Size size, const boost::shared_ptr< IborIndex > &index)
Disposable< Array > | initialValues () const
| returns the initial values of the state variables
Disposable< Array > | drift (Time t, const Array &x) const
| returns the drift part of the equation, i.e., \( \mu(t, \mathrm{x}_t) \)
Disposable< Matrix > | diffusion (Time t, const Array &x) const
| returns the diffusion part of the equation, i.e. \( \sigma(t, \mathrm{x}_t) \)
Disposable< Matrix > | covariance (Time t0, const Array &x0, Time dt) const
Disposable< Array > | apply (const Array &x0, const Array &dx) const
Disposable< Array > | evolve (Time t0, const Array &x0, Time dt, const Array &dw) const
Size | size () const
| returns the number of dimensions of the stochastic process
Size | factors () const
| returns the number of independent factors of the process
boost::shared_ptr< IborIndex > | index () const
Leg | cashFlows (Real amount=1.0) const
void | setCovarParam (const boost::shared_ptr< LfmCovarianceParameterization > &param)
boost::shared_ptr< LfmCovarianceParameterization > | covarParam () const
Size | nextIndexReset (Time t) const
const std::vector< Time > & | fixingTimes () const
const std::vector< Date > & | fixingDates () const
const std::vector< Time > & | accrualStartTimes () const
const std::vector< Time > & | accrualEndTimes () const
std::vector< DiscountFactor > | discountBond (const std::vector< Rate > &rates) const
Public Member Functions inherited from StochasticProcess
virtual Disposable< Array > | expectation (Time t0, const Array &x0, Time dt) const
virtual Disposable< Matrix > | stdDeviation (Time t0, const Array &x0, Time dt) const
virtual Time | time (const Date &) const
void | update ()
Public Member Functions inherited from Observer
| Observer (const Observer &)
Observer & | operator= (const Observer &)
std::pair< iterator, bool > | registerWith (const boost::shared_ptr< Observable > &)
void | registerWithObservables (const boost::shared_ptr< Observer > &)
Size | unregisterWith (const boost::shared_ptr< Observable > &)
void | unregisterWithAll ()
virtual void | deepUpdate ()
Public Member Functions inherited from Observable
| Observable (const Observable &)
Observable & | operator= (const Observable &)
void | notifyObservers ()

## Additional Inherited Members

Public Types inherited from Observer
typedef std::set< boost::shared_ptr< Observable > > | set_type
typedef set_type::iterator | iterator
Protected Member Functions inherited from StochasticProcess
| StochasticProcess (const boost::shared_ptr< discretization > &)
Protected Attributes inherited from StochasticProcess
boost::shared_ptr< discretization > | discretization_

## Detailed Description

libor-forward-model process

stochastic process of a libor forward model using the rolling forward measure incl. predictor-corrector step

References:

Glasserman, Paul, 2004, Monte Carlo Methods in Financial Engineering, Springer, Section 3.7

Antoon Pelsser, 2000, Efficient Methods for Valuing Interest Rate Derivatives, Springer, 8

Hull, John, White, Alan, 1999, Forward Rate Volatilities, Swap Rate Volatilities and the Implementation of the Libor Market Model (http://www.rotman.utoronto.ca/~amackay/fin/libormktmodel2.pdf)

Tests:
  the correctness is tested by Monte-Carlo reproduction of caplet & ratchet NPVs and comparison with Black pricing.

Warning:
  this class does not work correctly with Visual C++ 6.

## Member Function Documentation

## covariance()

Disposable<Matrix> covariance | ( | Time | t0,
|  | const Array & | x0,
|  | Time | dt
| ) |  | const

virtual

returns the covariance \( V(\mathrm{x}_{t_0 + \Delta t} | \mathrm{x}_{t_0} = \mathrm{x}_0) \) of the process after a time interval \( \Delta t \) according to the given discretization. This method can be overridden in derived classes which want to hard-code a particular discretization.

Reimplemented from StochasticProcess.

## apply()

Disposable<Array> apply | ( | const Array & | x0,
|  | const Array & | dx
| ) |  | const

virtual

applies a change to the asset value. By default, it returns \( \mathrm{x} + \Delta \mathrm{x} \).

Reimplemented from StochasticProcess.

## evolve()

Disposable<Array> evolve | ( | Time | t0,
|  | const Array & | x0,
|  | Time | dt,
|  | const Array & | dw
| ) |  | const

virtual

returns the asset value after a time interval \( \Delta t \) according to the given discretization. By default, it returns

\[ E(\mathrm{x}_0,t_0,\Delta t) + S(\mathrm{x}_0,t_0,\Delta t) \cdot \Delta \mathrm{w} \]

where \( E \) is the expectation and \( S \) the standard deviation.

Reimplemented from StochasticProcess.